"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var angular_1 = require("@jsonforms/angular");
var core_1 = require("@jsonforms/core");
var LayoutRenderer = /** @class */ (function (_super) {
    tslib_1.__extends(LayoutRenderer, _super);
    function LayoutRenderer(jsonFormsService, changeDetectionRef) {
        var _this = _super.call(this) || this;
        _this.jsonFormsService = jsonFormsService;
        _this.changeDetectionRef = changeDetectionRef;
        return _this;
    }
    LayoutRenderer.prototype.ngOnInit = function () {
        var _this = this;
        this.subscription = this.jsonFormsService.$state.subscribe({
            next: function (state) {
                var props = core_1.mapStateToLayoutProps(state, _this.getOwnProps());
                _this.hidden = !props.visible;
                _this.changeDetectionRef.markForCheck();
            }
        });
    };
    LayoutRenderer.prototype.ngOnDestroy = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    Object.defineProperty(LayoutRenderer.prototype, "renderProps", {
        get: function () {
            var _this = this;
            var elements = (this.uischema.elements || []).map(function (el) { return ({
                uischema: el,
                schema: _this.schema,
                path: _this.path
            }); });
            return elements;
        },
        enumerable: true,
        configurable: true
    });
    LayoutRenderer.prototype.trackElement = function (_index, renderProp) {
        return renderProp
            ? renderProp.path + JSON.stringify(renderProp.uischema)
            : null;
    };
    return LayoutRenderer;
}(angular_1.JsonFormsBaseRenderer));
exports.LayoutRenderer = LayoutRenderer;
//# sourceMappingURL=layout.renderer.js.map